#!/usr/bin/env python
# -*- coding: utf-8 -*-
#Wi-SUN Rx program
import serial
import datetime
import paho.mqtt.client as mqtt     # MQTTのライブラリをインポート
from time import sleep              # 3秒間のウェイトのために使う
con=serial.Serial('/dev/ttyUSB0',115200)
print(con.portstr)
status = ""
alert = False
# ブローカーに接続できたときの処理
def on_connect(client, userdata, flag, rc):
  print("Connected with result code " + str(rc))

# ブローカーが切断したときの処理
def on_disconnect(client, userdata, rc):
  if rc != 0:
     print("Unexpected disconnection.")

# publishが完了したときの処理
def on_publish(client, userdata, mid):
  print("publish: {0}".format(mid))

client = mqtt.Client()                 # クラスのインスタンス(実体)の作成
client.on_connect = on_connect         # 接続時のコールバック関数を登録
client.on_disconnect = on_disconnect   # 切断時のコールバックを登録
client.on_publish = on_publish         # メッセージ送信時のコールバック

client.connect("localhost", 1883, 60)  # 接続先は自分自身
 
  # 通信処理スタート
client.loop_start()    # subはloop_forever()だが，pubはloop_start()で起動だけさせる

while True:
    str_bf=con.readline()
    if str_bf !="":
        index = str_bf.find(b'ID:')
        if index !=-1:
            dt=datetime.datetime.now()
            print("")
            print(dt)
            index_end = str_bf.find(b'\x00')
            datastr = str_bf[index+3:index_end].decode()
            env_data = datastr.split(',')           
            Testmessage = ""
            sensorID = "".join(env_data)
            print("ID=",sensorID)
        
        index = str_bf.find(b'GNSS:')
        if index !=-1:
            index_end = str_bf.find(b'\x00')
            datastr = str_bf[index+5:index_end].decode()
            env_data = datastr.split(',')            
            gnss = "".join(env_data)
            print("GNSS=",gnss)            

        index = str_bf.find(b'DEGREE:')
        if index !=-1:
            index_end = str_bf.find(b'\x00')
            datastr = str_bf[index+7:index_end].decode()
            env_data = datastr.split(',')            
            degree = "".join(env_data)
            print("DEGREE=",degree)
        
        index = str_bf.find(b'STATUS:')
        if index !=-1:
            index_end = str_bf.find(b'\x00')
            datastr = str_bf[index+7:index_end].decode()
            env_data = datastr.split(',')            
            status = "".join(env_data)
            print("STATUS=",status)
        
        index = str_bf.find(b'alert')
        if index !=-1:
            print("alert find")
 #           client.publish("sensorID",sensorID)
            client.publish("alert",sensorID)
            alert

    if (alert == True):
        print("alert")
        client.publish("alert","alert2")

con.close()